
#include "common.h"

/*
 * ===================================
 * Update all timers
 * ===================================
 */
void CALLCONV PB_ExamineTimers()
{
	integer TimerID;
	PB_Timer *Timer;
	unsigned __int64 currentTime;

	QueryPerformanceCounter( (LARGE_INTEGER*)&currentTime );

	PB_Object_EnumerateStart( PB_Timer_Objects );

	while ( PB_Object_EnumerateNext( PB_Timer_Objects, &TimerID ) ) {
		Timer = PB_Timer_GetObject( TimerID );

		if ( Timer->status == PB_TIMERSTATUS_RING )
			Timer->status = PB_TIMERSTATUS_WAIT;

		if ( Timer->timeOut > currentTime || Timer->status == PB_TIMERSTATUS_NONE ) {
			continue;
		} else {
			Timer->status = PB_TIMERSTATUS_RING;
			Timer->timeOut = currentTime + Timer->intervalTicks;

			if ( Timer->callback )
				Timer->callback();
		}
	}
}