/*
 * Time lib for purebasic Windows x64 
 * xorc1zt
 * 2012
 */

#include "common.h"

unsigned __int64 startTime_g;
unsigned __int64 rawFrequency_g;
float dsFrequency_g;
float csFrequency_g;
float msFrequency_g;
float usFrequency_g;
float nsFrequency_g;

PB_Object *PB_Timer_Objects;

/*
 * ===================================
 * Free a timer object
 * ===================================
 */
void CALLCONV PB_FreeTimer( integer TimerID )
{
	PB_Timer *Timer;

	if ( Timer = PB_Timer_GetObject( TimerID ) ) {
		PB_Timer_FreeID( TimerID );
	}
}

/*
 * ===================================
 * InitFunction
 * ===================================
 */
void CALLCONV PB_InitTime()
{
	QueryPerformanceCounter( (LARGE_INTEGER*)&startTime_g );
	QueryPerformanceFrequency( (LARGE_INTEGER*)&rawFrequency_g );

	dsFrequency_g = (float)rawFrequency_g * 10e-2f;
	csFrequency_g = (float)rawFrequency_g * 10e-3f;
	msFrequency_g = (float)rawFrequency_g * 10e-4f;
	usFrequency_g = (float)rawFrequency_g * 10e-7f;
	nsFrequency_g = (float)rawFrequency_g * 10e-10f;

	PB_Timer_Objects = PB_Object_Init( sizeof( PB_Timer ), 1, &PB_FreeTimer );
}

/*
 * ===================================
 * EndFunction
 * ===================================
 */
void CALLCONV PB_EndTime()
{
	integer TimerID;
  
	PB_Object_EnumerateStart( PB_Timer_Objects );

	while ( PB_Object_EnumerateNext( PB_Timer_Objects, &TimerID ) ) {
		PB_FreeTimer( TimerID );
	}
}